//////////// Notes
    //
    //  0.0.8 Using apply in method
    //      This is relevant to the chain function which takes 2 arguments instead of 1, as the other functions do.
    //
////////////
var recfun;
recfun = function()
{
    this.history = [];
    this.mutations = [];
    this.states = [];
    this.debug = false;
    this.checkpoint = 0;
};
if(typeof window === "undefined")
{
    var exports = module.exports = {};
    exports.recfun = recfun;
}
var method = function(n,f)
{
    recfun.prototype[n] = (function(o){
            if(this.debug){
                console.log(this);
            }
            return f.apply(this,arguments);
    });
};
method( "getState",function getState(state_index)
    {

        if(typeof state_index === "undefined")return this.states[this.states.length-1];
        if(!this.states[state_index])return "Unexecuted Context";
        return this.states[state_index];
    }
);
method("printHistory",function(){
    for(var i=0;i<this.history.length;i++){
        console.log(this.history[i] + "");
    }
});
method("printMutations",function(){
    for(var i=0;i<this.mutations.length;i++){
        console.log(this.mutations[i] + "");
    }
});
method("toString",function(){
    if(typeof window === "undefined")
    {
        console.log(this);
        return 0;
    }else{
        var toolbox_context = (function()
        {
            ////////// toolbox
                //
                var root = document.body;
                var log = function(){};
                log.prototype.print = function(s,b)
                {
                    if(typeof window !== "undefined")
                    {
                        var f = document.createElement("span");
                        f.innerHTML = s;
                        s = s*10;
                        f.style.display = "inline-block";
                        f.style.textAlign = "center";
                        f.style.lineHeight = s + "px";
                        f.style.height = s + "px";
                        f.style.width = s + "px";
                        f.style.border = "black solid 1px"; // "+ s + "px";
                        root.appendChild(f)
                        if(b){
                            var p = document.createElement("p");
                            var txt = document.createTextNode(b);
                            p.appendChild(txt);
                            root.appendChild(p);
                        }
                    }
                    else
                    {
                        log+=s;
                    }
                }
                log.prototype.println=function(s,b)
                {
                    if(typeof window !== "undefined")
                    {
                        var f = document.createElement("div");
                        if(typeof arguments[0] === "undefined"){
                            f.innerHTML = "";
                        }else{
                            f.innerHTML = s;
                        }
                        root.appendChild(f);
                        var more_info = document.createElement("button");
                        root.appendChild(more_info);
                        if(b){
                            var p = document.createElement("p");
                            p.style.position = "relative";
                            p.style.left = "10%";
                            p.style.width = "88.32%";
                            p.style.display = "none";
                            var txt = document.createTextNode(b);
                            p.appendChild(txt);
                            root.appendChild(p);
                        }
                        more_info.innerHTML = ">";
                        more_info.addEventListener("click",function(e){
                            if(p.style.display === "none"){
                                p.style.display="inline";
                                e.currentTarget.innerHTML = "v";
                            }else{
                                p.style.display="none";
                                e.currentTarget.innerHTML = ">";
                            }
                        })
                    }
                    else
                    {

                        if(log){
                            console.log(log);
                        }
                        log = "";
                    }
                }
                //
            ////////// end-toolbox
                return {
                    log:new log
                };
        })();
        for(var prop in this)
        {
            toolbox_context.log.println(prop,this[prop]);
        }
    }
});
// recfun.prototype.injectContext = function injectContext(f_context,f_final)// probably a better name: context_inject
// i am not even using this now that I have chain
method("injectContext",function(f_context,f_final)
{
    return function(o)
    {
        return f_final.call(f_context(),o);
    };
});
// recfun.prototype.chain = function chain(f_context,f_final)// probably a better name: context_inject
method("chain",function(f_context,f_final)
{
    return function(o)
    {
        return f_final(f_context(o));
    };
});
// recfun.prototype.run = function run(from)// good enough
method("run",function run(from)// good enough
{
    var context;
    var functionChain
    if(from){
        functionChain = this.history.filter(function(v,i,r)
            {
                return i>=from;
            }
        );
    }else{
        functionChain = this.history;
    }
    functionChain.forEach(function(v,i,r)
        {
            context = v(context);
        }
    );
    return context;
});
// recfun.prototype.checkout = function checkout()// good enough
method("checkout",function checkout()// good enough
{
    var context = this.history[this.checkpoint]();
    for(var i=this.checkpoint+1;i<this.history.length;i++)
    {

        this.states.push(context);
        context = this.history[i](context);
    }
    this.states.push(context);
    this.history.push(function()
        {
            return context;
        }
    );
    this.checkpoint = this.history.length-1;
    return context;
});
// recfun.prototype.close = function close(func) // maybe a better name enclose/wrap
method("close",function (func) // maybe a better name enclose/wrap
{
    if(this.debug){
        console.log(this);
    }
    if(typeof func !== "function")
    {
        console.log("That's not a function");
        return 0;
    }
    this.history.push(func);
});
// recfun.prototype.set = function set(i) //maybe a better name
method("set",function(i)
{
  this.checkpoint = i;
});
// recfun.prototype.unshift = function(context)
method("unshift",function(context)
{
    this.history.unshift(function()
        {
            return context;
        }
    )
});
// recfun.prototype.collapse = function()
method("collapse",function()
{   var _ = this;
    return function(){
        return _.run.apply(_,arguments);
    }
});
// recfun.prototype.mutate
method("mutate",function(fn){
    //must be a mutate function;
    this.mutations.push(fn);
    this.history[0]=this.chain(this.history[0],fn);
});

method("seed",function(arg){
    console.log(arg);
    var context;
    var functionChain = this.history;
    functionChain.forEach(function(v,i,r)
        {
            if(i==0){
                context=v(arg);
            }else{
                context = v(context);
            }
        }
    );
    return context;
});

method("link",function(index,arg){
    return this.history[index](arg);
});
method("remove",function(index){
    var new_history=[];
    for(var i=0;i<this.history.length;i++){
        if(i!=index){
            new_history.push(this.history[i]);
        }
    }
    this.history = new_history;
})