
////////// Fun
    //
    var Fun = function(){
        this.history = [];
        this.states = [];
        this.checkpoint = 0;
    };
    Fun.prototype.chain = function chain(f_context,f_final){
        return function(o){
            // console.log(f_context)
            return f_final.call(f_context(),o);
        };
    };
    Fun.prototype.getState = function getState(i){
        return this.states[i]|this.checkout(i);
    };
    Fun.prototype.run = function run(from){
        var context; // initial condition
        var functionChain
        if(from){
            functionChain = this.history.filter(function(v,i,r){
                return i>=from;
            });
        }else{
            functionChain = this.history;
        }
        functionChain.forEach(function(v,i,r)
            {
                // console.log(v);
                context = v(context);
            }
        );
        return context;
    };
    Fun.prototype.checkout = function checkout(stopAt){
        var context = this.history[this.checkpoint](); // initial condition
        for(var i=this.checkpoint+1;i<this.history.length;i++){
            this.states.push(context);
            context = this.history[i](context);
            if(stopAt&&stopAt===i){
                break;
            }
        }
        this.history.push(function(){
            return context;
        });
        this.checkpoint = this.history.length-1;
        return context;
    };
    Fun.prototype.close = function close(func){
        console.log(this);
        if(typeof func !== "function"){
            return 0;
        }
        //old
            // if(exec){
            //     this.checkpoint = this.history.length;
            //     var run = this.run();
            //     // console.log(run);
            //     // console.log(func);
            //     var ret = this.history.push(function(){return func(run)});
            //     return ret;
            // }else{...}
        this.history.push(func);
    };
    Fun.prototype.set = function close(i){
      this.checkpoint = i;
    };
    Fun.prototype.unshift = function(context){
        this.history.unshift(function(){
            return context;
        })
    };
    //
//////////

////////// system
    // model: data
    //  |
    // controller: app logic
    //  |
    // view: browser/node
//////////
var recn = new Fun();

//
var model = function()
{
    // get-model-snapshot
    return "11111111011111";
};
recn.close(model);
//
var controller = function(o)
{
    //takes in model output
    return o.split("").map(
        function(v,i,r)
        {
            return 1 == parseInt(v);
        }
    );
};
recn.close(controller);
//
var view = function(o)
{
    //takes in controller output
    var log = this.log;
    var slab = "###########";
    log.println(slab);log.print("#");
    o.forEach(function(v,i,r){
        // console.log(that);
        if(v)
        {
            log.print(i);
        }
        else
        {
            log.print("#");log.println();log.print("#");
        }
    });
    log.print("#");
    log.println(slab);
    return o;
};
//
var toolbox_context = function(){
    ////////// toolbox
        //
        var log = function(){
            // this.max_width = 5;
            // this.buffer = 0;
        };
        log.prototype.print = function(s)
        {
            if(typeof window !== "undefined")
            {
                var f = document.createElement("span");
                f.innerHTML = s;
                s = s*10;
                f.style.display = "inline-block";
                f.style.textAlign = "center";
                f.style.lineHeight = s + "px";
                f.style.height = s + "px";
                f.style.width = s + "px";
                f.style.border = "black solid 1px"; // "+ s + "px";
                document.body.appendChild(f)
            }
            else
            {
                log+=s;
            }
        }
        log.prototype.println=function(s)
        {
            if(typeof window !== "undefined")
            {
                    var f = document.createElement("div");
                if(typeof arguments[0] === "undefined"){
                    f.innerHTML = "";
                }else{
                    f.innerHTML = s;
                }
                    document.body.appendChild(f);
            }
            else
            {

                if(log){
                    console.log(log);
                }
                log = "";
            }
        }
        //
    ////////// end-toolbox
    return {
        log:new log
    };
};
    // toolbox_context -> view
recn.close(recn.chain(toolbox_context,view));
//
recn.checkout();
recn.close(function(o){
    console.log(o);
})